"use strict";

exports.__esModule = true;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

require("./ReactTimePicki.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactTimePicki = function (_React$Component) {
	_inherits(ReactTimePicki, _React$Component);

	function ReactTimePicki(props) {
		_classCallCheck(this, ReactTimePicki);

		var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

		_this.state = {
			showPicker: false,
			currentDate: new Date(),
			meridian: "AM",
			time: {
				hr: _this
				//min: this.state.currentDate.getMinutes()
			},
			value: _this.props.value ? _this.props.value : ''
		};
		_this.timePickiClickHandler = _this.timePickiClickHandler.bind(_this);
		_this.setValueClickHandler = _this.setValueClickHandler.bind(_this);
		return _this;
	}

	ReactTimePicki.prototype.timePickiClickHandler = function timePickiClickHandler() {
		var showPicker = this.state.showPicker;
		if (showPicker) {
			return;
		} else {}
		var currentDate = new Date();
		var currentHours = currentDate.getHours();
		var meridian = "AM";
		if (this.props.timeFormat && this.props.timeFormat === "12") {
			meridian = Math.floor(currentHours / 12) === 1 ? "PM" : "AM";
			currentHours = currentHours % 12;
			currentHours = currentHours === 0 ? 12 : currentHours;
		}
		this.setState({
			showPicker: true,
			currentHours: currentHours,
			currentMinutes: currentDate.getMinutes(),
			meridian: meridian
		});
	};

	ReactTimePicki.prototype.valueChangeHours = function valueChangeHours(e) {
		var currentHours = e.target.value.replace(/[^0-9.]/g, '');
		var meridian = "AM";
		if (this.props.timeFormat === "12" && 12 < currentHours) {
			meridian = Math.floor(currentHours / 12) === 1 ? "PM" : "AM";
			currentHours = 12;
		} else if (this.props.timeFormat === "24" && 23 < currentHours) {
			currentHours = 23;
		} else {
			//("0"+currentHours).split(-2)
		}
		this.setState({ currentHours: currentHours, meridian: meridian });
	};

	ReactTimePicki.prototype.valueChangeMinutes = function valueChangeMinutes(e) {
		var currentMinutes = e.target.value.replace(/[^0-9.]/g, '');
		if (59 < currentMinutes) {
			currentMinutes = 59;
		}
		this.setState({ currentMinutes: currentMinutes });
	};

	ReactTimePicki.prototype.setValueClickHandler = function setValueClickHandler() {
		var setTime = "";
		var getTime = {};
		if (this.props.timeFormat === "12") {
			setTime = ("0" + this.state.currentHours).slice(-2) + " : " + ("0" + this.state.currentMinutes).slice(-2) + " : " + this.state.meridian;
			getTime.hour = ("0" + this.state.currentHours).slice(-2);
			getTime.mins = ("0" + this.state.currentMinutes).slice(-2);
			getTime.mer = this.state.meridian;
		} else {
			setTime = ("0" + this.state.currentHours).slice(-2) + " : " + ("0" + this.state.currentMinutes).slice(-2);
			getTime.hour = ("0" + this.state.currentHours).slice(-2);
			getTime.mins = ("0" + this.state.currentMinutes).slice(-2);
		}
		this.setState({ value: setTime, showPicker: false });
		this.props.getTime(setTime, getTime);
	};

	ReactTimePicki.prototype.resetValueClickHandler = function resetValueClickHandler() {
		this.setState({ value: "" });
	};

	ReactTimePicki.prototype.closeClickHandler = function closeClickHandler() {
		this.setState({ showPicker: false });
	};

	ReactTimePicki.prototype.arrowClickHandler = function arrowClickHandler(field, direction, e) {
		if (field === 'hour' && direction === "up") {
			if (this.props.timeFormat === "24" && this.state.currentHours < 24 || this.props.timeFormat === "12" && this.state.currentHours < 12) {
				this.setState({ currentHours: this.state.currentHours + 1 });
			} else if (this.props.timeFormat === "24" && 23 < this.state.currentHours) {
				this.setState({ currentHours: 0 });
			} else if (this.props.timeFormat === "12" && 12 <= this.state.currentHours) {
				this.setState({ currentHours: 1 });
			}
		} else if (field === 'hour' && direction === "down") {
			if (this.state.currentHours !== 0 && (this.props.timeFormat === "12" && this.state.currentHours !== 1 || this.props.timeFormat === "24")) {
				this.setState({ currentHours: this.state.currentHours - 1 });
			} else if (this.props.timeFormat === "24" && this.state.currentHours === 0) {
				this.setState({ currentHours: 23 });
			} else if (this.props.timeFormat === "12" && this.state.currentHours === 0) {
				this.setState({ currentHours: 12 });
			} else {
				this.setState({ currentHours: 12 });
			}
		} else if (field === 'min' && direction === "up") {
			if (this.state.currentMinutes < 59) {
				this.setState({ currentMinutes: this.state.currentMinutes + 1 });
			} else {
				this.setState({ currentMinutes: 0 });
			}
		} else if (field === 'min' && direction === "down") {
			if (this.state.currentMinutes !== 0) {
				this.setState({ currentMinutes: this.state.currentMinutes - 1 });
			} else {
				this.setState({ currentMinutes: 59 });
			}
		} else if (field === 'meri' && (direction === "down" || direction === "up")) {
			var meridian = this.state.meridian === 'AM' ? 'PM' : 'AM';
			this.setState({ meridian: meridian });
		}
	};

	ReactTimePicki.prototype.renderTimepicki = function renderTimepicki() {
		if (this.state.showPicker) {
			return _react2.default.createElement(
				"div",
				{ className: "timepicki-container " + this.renderWidthClass() },
				_react2.default.createElement(
					"span",
					{ onClick: this.closeClickHandler.bind(this), className: "close-icon" },
					_react2.default.createElement(
						"strong",
						null,
						"x"
					)
				),
				_react2.default.createElement(
					"div",
					{ className: "timepicki-input-wrap timepicki-input-wrap-left" },
					_react2.default.createElement("span", { className: "timepicki-arrow up-arrow", onClick: this.arrowClickHandler.bind(this, "hour", "up") }),
					_react2.default.createElement(
						"span",
						null,
						_react2.default.createElement("input", { className: "timepicki-input", type: "text", maxLength: "2", onChange: this.valueChangeHours.bind(this), value: this.state.currentHours, name: "" })
					),
					_react2.default.createElement("span", { className: "timepicki-arrow down-arrow", onClick: this.arrowClickHandler.bind(this, "hour", "down") })
				),
				_react2.default.createElement(
					"div",
					{ className: "timepicki-input-wrap" },
					_react2.default.createElement("span", { className: "timepicki-arrow up-arrow", onClick: this.arrowClickHandler.bind(this, "min", "up") }),
					_react2.default.createElement(
						"span",
						null,
						_react2.default.createElement("input", { className: "timepicki-input", type: "text", maxLength: "2", onChange: this.valueChangeMinutes.bind(this), value: this.state.currentMinutes, name: "" })
					),
					_react2.default.createElement("span", { className: "timepicki-arrow down-arrow", onClick: this.arrowClickHandler.bind(this, "min", "down") })
				),
				this.renderMeridian(),
				_react2.default.createElement(
					"div",
					{ className: "timepicki-button-container" },
					_react2.default.createElement(
						"button",
						{ className: "timepicki-button timepicki-done-button", onClick: this.setValueClickHandler.bind(this) },
						"Done"
					),
					_react2.default.createElement(
						"button",
						{ className: "timepicki-button timepicki-reset-button", onClick: this.resetValueClickHandler.bind(this) },
						"Reset"
					)
				)
			);
		} else {
			return null;
		}
	};

	ReactTimePicki.prototype.renderWidthClass = function renderWidthClass() {
		if (this.props.timeFormat === "12") {
			return "timepicki-container-normal";
		} else return "timepicki-container-meridian";
	};

	ReactTimePicki.prototype.renderMeridian = function renderMeridian() {
		if (this.props.timeFormat === "12") {
			return _react2.default.createElement(
				"div",
				{ className: "timepicki-input-wrap timepicki-input-wrap-right" },
				_react2.default.createElement("span", { className: "timepicki-arrow up-arrow", onClick: this.arrowClickHandler.bind(this, "meri", "up") }),
				_react2.default.createElement(
					"span",
					null,
					_react2.default.createElement("input", { className: "timepicki-input", type: "text", maxLength: "2", name: "", value: this.state.meridian, readOnly: true })
				),
				_react2.default.createElement("span", { className: "timepicki-arrow down-arrow", onClick: this.arrowClickHandler.bind(this, "meri", "down") })
			);
		} else return null;
	};

	ReactTimePicki.prototype.render = function render() {
		var _this2 = this;

		return _react2.default.createElement(
			"div",
			{ className: "input-wrapper" },
			_react2.default.createElement("input", { type: "text", onClick: this.timePickiClickHandler, value: this.state.value, placeholder: this.props.placeholder, onChange: function onChange(e) {
					return _this2.props.onChange && _this2.props.onChange(e.target.value);
				} }),
			this.renderTimepicki()
		);
	};

	return ReactTimePicki;
}(_react2.default.Component);

exports.default = ReactTimePicki;
module.exports = exports["default"];